//---------------------------------------------------------------------------

#include <vcl.h>
#include <winbase.h>
#include <winioctl.h>
#pragma hdrstop

#include "unitpporttest.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TformPPortTest *formPPortTest;
TCheckBox *checkBoxD[8];
TCheckBox *checkBoxC[5];
TCheckBox *checkBoxS[6];
TLabel *labelS[6];
HANDLE hSmallPort = INVALID_HANDLE_VALUE;

#define BASE 0x378

// parallel port registers

#define DATA    BASE + 0
#define STATUS  BASE + 1
#define CONTROL BASE + 2

// data bits

#define D7 128
#define D6 64
#define D5 32
#define D4 16
#define D3 8
#define D2 4
#define D1 2
#define D0 1

BYTE D[8] = {D0, D1, D2, D3, D4, D5, D6, D7};

// status bits

#define S7                     128
#define S6                     64
#define S5                     32
#define S4                     16
#define S3                     8
#define SNOTINTERRUPTREQUESTED 4

BYTE S[6] = {SNOTINTERRUPTREQUESTED, S3, S4, S5, S6, S7};

// control bits

#define CINTERRUPTENABLED 16
#define C3                8
#define C2                4
#define C1                2
#define C0                1

BYTE C[5] = {C0, C1, C2, C3, CINTERRUPTENABLED};

#define FILE_DEVICE_SMALLPORT 61696
#define IOCTL_READ_BYTE  CTL_CODE(FILE_DEVICE_SMALLPORT, 0x0901, METHOD_BUFFERED, FILE_READ_ACCESS)
#define IOCTL_WRITE_BYTE CTL_CODE(FILE_DEVICE_SMALLPORT, 0x0902, METHOD_BUFFERED, FILE_WRITE_ACCESS)

typedef struct _BYTEPORT {
        unsigned short address;
        BYTE value;
} BYTEPORT, *PBYTEPORT;

//---------------------------------------------------------------------------
__fastcall TformPPortTest::TformPPortTest(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
HANDLE smallPortOpen()
{
        return CreateFile(
                "\\\\.\\Smport",
                GENERIC_READ | GENERIC_WRITE,
                0,
                NULL,
                OPEN_EXISTING,
                FILE_ATTRIBUTE_NORMAL,
                NULL
        );
}
//---------------------------------------------------------------------------
void smallPortClose()
{
        if (hSmallPort != INVALID_HANDLE_VALUE)
                CloseHandle(hSmallPort);
}
//---------------------------------------------------------------------------
BYTE smallPortRead(Word ioAddress)
{
        if (hSmallPort != INVALID_HANDLE_VALUE)
        {
                Word data;
                DWORD cbBytesReturned;
                if (
                        DeviceIoControl(
                                hSmallPort,
                                IOCTL_READ_BYTE,
                                &ioAddress,
                                sizeof(ioAddress),
                                &data,
                                sizeof(data),
                                &cbBytesReturned,
                                NULL
                        )
                )
                        return LOBYTE(data);
                else
                        return 0;
        }
        else
                return 0;
}
//---------------------------------------------------------------------------
void smallPortWrite(Word ioAddress, BYTE data)
{
        if (hSmallPort != INVALID_HANDLE_VALUE)
        {
                BYTEPORT bytePort;
                Word value;
                DWORD cbBytesReturned;
                bytePort.address = ioAddress;
                bytePort.value   = data;
                DeviceIoControl(
                        hSmallPort,
                        IOCTL_WRITE_BYTE,
                        &bytePort,
                        sizeof(bytePort),
                        &value,
                        sizeof(value),
                        &cbBytesReturned,
                        NULL
                );
        }
}
//---------------------------------------------------------------------------
void __fastcall TformPPortTest::FormCreate(TObject *Sender)
{
        checkBoxD[7] = checkBoxD7;
        checkBoxD[6] = checkBoxD6;
        checkBoxD[5] = checkBoxD5;
        checkBoxD[4] = checkBoxD4;
        checkBoxD[3] = checkBoxD3;
        checkBoxD[2] = checkBoxD2;
        checkBoxD[1] = checkBoxD1;
        checkBoxD[0] = checkBoxD0;
        checkBoxC[4] = checkBoxCInterruptEnabled;
        checkBoxC[3] = checkBoxC3;
        checkBoxC[2] = checkBoxC2;
        checkBoxC[1] = checkBoxC1;
        checkBoxC[0] = checkBoxC0;
        checkBoxS[5] = checkBoxS7;
        checkBoxS[4] = checkBoxS6;
        checkBoxS[3] = checkBoxS5;
        checkBoxS[2] = checkBoxS4;
        checkBoxS[1] = checkBoxS3;
        checkBoxS[0] = checkBoxSNotInterruptRequested;
        labelS[5] = labelS7;
        labelS[4] = labelS6;
        labelS[3] = labelS5;
        labelS[2] = labelS4;
        labelS[1] = labelS3;
        labelS[0] = labelSInterruptRequested;
        if ((hSmallPort = smallPortOpen()) == INVALID_HANDLE_VALUE)
        {
                MessageBox(Handle, "Kon de parallelle poort niet openen.\nControleer of de SmallPort driver is ingeschakeld.", Caption.c_str(), MB_ICONERROR);
                Application->Terminate();
        }
}
//---------------------------------------------------------------------------
void __fastcall TformPPortTest::FormDestroy(TObject *Sender)
{
        smallPortClose;
}
//---------------------------------------------------------------------------
void __fastcall TformPPortTest::checkBoxClick(TObject *Sender)
{
        BYTE b;
        // output all data bits
        b = 0;
        for (int i = 7; i >= 0; i--)
                if (checkBoxD[i]->Checked)
                        b = b | D[i];
        smallPortWrite(DATA, b);
        // output all control bits
        b = 0;
        for (int i = 4; i >= 0; i--)
                if (checkBoxC[i]->Checked)
                        b = b | C[i];
        smallPortWrite(CONTROL, b);
}
//---------------------------------------------------------------------------
void __fastcall TformPPortTest::timerSRefreshTimer(TObject *Sender)
{
        BYTE b;
        BOOLEAN newState;
        // read all data bits
        b = smallPortRead(DATA);
        for (int i = 7; i >= 0; i--)
                checkBoxD[i]->Checked = ((b & D[i]) == D[i]);
        // read all control bits
        b = smallPortRead(CONTROL);
        for (int i = 4; i >= 0; i--)
                checkBoxC[i]->Checked = ((b & C[i]) == C[i]);
        // read all status bits
        b = smallPortRead(STATUS);
        for (int i = 5; i >= 0; i--)
        {
                newState = ((b & S[i]) == S[i]);
                if (newState != checkBoxS[i]->Checked)
                {
                        labelS[i]->Caption = IntToStr(labelS[i]->Caption.ToInt() + 1);
                        checkBoxS[i]->Checked = newState;
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TformPPortTest::labelSClick(TObject *Sender)
{
        ((TEdit *)Sender)->Text = "0";
}
//---------------------------------------------------------------------------

